(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("rxjs"), require("rxjs/operators"), require("tslib"));
	else if(typeof define === 'function' && define.amd)
		define("redogs", ["rxjs", "rxjs/operators", "tslib"], factory);
	else if(typeof exports === 'object')
		exports["redogs"] = factory(require("rxjs"), require("rxjs/operators"), require("tslib"));
	else
		root["redogs"] = factory(root["rxjs"], root["rxjs"]["operators"], root["tslib"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE_rxjs__, __WEBPACK_EXTERNAL_MODULE_rxjs_operators__, __WEBPACK_EXTERNAL_MODULE_tslib__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/dist/";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/actions.ts":
/*!************************!*\
  !*** ./src/actions.ts ***!
  \************************/
/*! exports provided: createStandardAction, getType, isActionOf */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"createStandardAction\", function() { return createStandardAction; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"getType\", function() { return getType; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"isActionOf\", function() { return isActionOf; });\n// Constructors\nvar createStandardAction = function (type) {\n    var ctor = function (payload) { return ({ type: type, payload: payload }); };\n    ctor.type = type;\n    return function () { return ctor; };\n};\n// Redux\n// helper to use in switch-case\nvar getType = function (actionCtor) { return actionCtor.type; };\n// Effects\n// helper for pipe filtering in effects\nvar isActionOf = function (actionCtors) {\n    return function (action) {\n        return actionCtors.some(function (ctor) { return ctor.type === action.type; });\n    };\n};\n\n\n\n//# sourceURL=webpack://redogs/./src/actions.ts?");

/***/ }),

/***/ "./src/combineEffects.ts":
/*!*******************************!*\
  !*** ./src/combineEffects.ts ***!
  \*******************************/
/*! exports provided: combineEffects */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"combineEffects\", function() { return combineEffects; });\n/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ \"tslib\");\n/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! rxjs */ \"rxjs\");\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(rxjs__WEBPACK_IMPORTED_MODULE_1__);\n\n\nvar combineEffects = function () {\n    var effects = [];\n    for (var _i = 0; _i < arguments.length; _i++) {\n        effects[_i] = arguments[_i];\n    }\n    return function (action$, state$) { return rxjs__WEBPACK_IMPORTED_MODULE_1__[\"merge\"].apply(void 0, Object(tslib__WEBPACK_IMPORTED_MODULE_0__[\"__spread\"])([rxjs__WEBPACK_IMPORTED_MODULE_1__[\"NEVER\"]], effects.map(function (effect) { return effect(action$, state$); }))); };\n};\n\n\n//# sourceURL=webpack://redogs/./src/combineEffects.ts?");

/***/ }),

/***/ "./src/combineReducers.ts":
/*!********************************!*\
  !*** ./src/combineReducers.ts ***!
  \********************************/
/*! exports provided: combineReducers */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"combineReducers\", function() { return combineReducers; });\n/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ \"tslib\");\n/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);\n\nvar combineReducers = function (reducers, initialState) {\n    var entries = Object.entries(reducers);\n    var initialStateSafe = initialState != null\n        ? initialState\n        : Object.create(null);\n    return function (action, state) {\n        if (state === void 0) { state = initialStateSafe; }\n        // shallow check if store branch was updated\n        var shouldUpdate = false;\n        var newState = entries.reduce(\n        // [any, any] TS hack\n        function (acc, _a) {\n            var _b = Object(tslib__WEBPACK_IMPORTED_MODULE_0__[\"__read\"])(_a, 2), key = _b[0], fn = _b[1];\n            acc[key] = fn(action, state[key] || void 0);\n            if (acc[key] !== state[key]) {\n                shouldUpdate = true;\n            }\n            return acc;\n        }, Object.create(null));\n        return shouldUpdate\n            ? newState\n            : state;\n    };\n};\n\n\n//# sourceURL=webpack://redogs/./src/combineReducers.ts?");

/***/ }),

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/*! exports provided: INIT_STORE_ACTION, createStore, createStandardAction, getType, isActionOf, combineEffects, combineReducers */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony import */ var _store__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./store */ \"./src/store.ts\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"INIT_STORE_ACTION\", function() { return _store__WEBPACK_IMPORTED_MODULE_0__[\"INIT_STORE_ACTION\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"createStore\", function() { return _store__WEBPACK_IMPORTED_MODULE_0__[\"createStore\"]; });\n\n/* harmony import */ var _actions__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./actions */ \"./src/actions.ts\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"createStandardAction\", function() { return _actions__WEBPACK_IMPORTED_MODULE_1__[\"createStandardAction\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"getType\", function() { return _actions__WEBPACK_IMPORTED_MODULE_1__[\"getType\"]; });\n\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"isActionOf\", function() { return _actions__WEBPACK_IMPORTED_MODULE_1__[\"isActionOf\"]; });\n\n/* harmony import */ var _combineEffects__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./combineEffects */ \"./src/combineEffects.ts\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"combineEffects\", function() { return _combineEffects__WEBPACK_IMPORTED_MODULE_2__[\"combineEffects\"]; });\n\n/* harmony import */ var _combineReducers__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./combineReducers */ \"./src/combineReducers.ts\");\n/* harmony reexport (safe) */ __webpack_require__.d(__webpack_exports__, \"combineReducers\", function() { return _combineReducers__WEBPACK_IMPORTED_MODULE_3__[\"combineReducers\"]; });\n\n\n\n\n\n\n\n//# sourceURL=webpack://redogs/./src/index.ts?");

/***/ }),

/***/ "./src/store.ts":
/*!**********************!*\
  !*** ./src/store.ts ***!
  \**********************/
/*! exports provided: INIT_STORE_ACTION, createStore */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
eval("__webpack_require__.r(__webpack_exports__);\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"INIT_STORE_ACTION\", function() { return INIT_STORE_ACTION; });\n/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, \"createStore\", function() { return createStore; });\n/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ \"tslib\");\n/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! rxjs */ \"rxjs\");\n/* harmony import */ var rxjs__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(rxjs__WEBPACK_IMPORTED_MODULE_1__);\n/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! rxjs/operators */ \"rxjs/operators\");\n/* harmony import */ var rxjs_operators__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__);\n\n\n\n;\nvar INIT_STORE_ACTION = { type: 'INIT_STORE' };\n// }}}\nvar createStore = function (reducersRoot, effectsRoot) {\n    var actions$ = new rxjs__WEBPACK_IMPORTED_MODULE_1__[\"Subject\"]();\n    var state$ = new rxjs__WEBPACK_IMPORTED_MODULE_1__[\"ReplaySubject\"](1);\n    var destroy$ = new rxjs__WEBPACK_IMPORTED_MODULE_1__[\"Subject\"]();\n    // reducers\n    actions$.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__[\"withLatestFrom\"])(state$.pipe(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__[\"startWith\"])(void 0))), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__[\"map\"])(function (_a) {\n        var _b = Object(tslib__WEBPACK_IMPORTED_MODULE_0__[\"__read\"])(_a, 2), action = _b[0], state = _b[1];\n        return reducersRoot(action, state);\n    }), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__[\"distinctUntilChanged\"])(), suppressAndLogError('[redogs:store]'), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__[\"takeUntil\"])(destroy$)).subscribe(state$);\n    // effects\n    if (typeof effectsRoot == 'function') {\n        effectsRoot(actions$, state$).pipe(suppressAndLogError('[redogs:effects]'), Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__[\"takeUntil\"])(destroy$))\n            .subscribe(actions$);\n    }\n    // init store\n    actions$\n        .next(INIT_STORE_ACTION);\n    return {\n        state$: state$.asObservable(),\n        dispatch: function (action) {\n            actions$.next(action);\n        },\n        destroy$: destroy$\n    };\n};\n\n// Helpers\nfunction suppressAndLogError(msgPrefix) {\n    return Object(rxjs__WEBPACK_IMPORTED_MODULE_1__[\"pipe\"])(Object(rxjs_operators__WEBPACK_IMPORTED_MODULE_2__[\"catchError\"])(function (err) {\n        // NOTE: basically, we're suppressing errors here\n        if (console && typeof console.error == 'function') {\n            console.error(msgPrefix, err);\n        }\n        return rxjs__WEBPACK_IMPORTED_MODULE_1__[\"EMPTY\"];\n    }));\n}\n\n\n//# sourceURL=webpack://redogs/./src/store.ts?");

/***/ }),

/***/ "rxjs":
/*!************************************************************************************!*\
  !*** external {"root":["rxjs"],"commonjs":"rxjs","commonjs2":"rxjs","amd":"rxjs"} ***!
  \************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

eval("module.exports = __WEBPACK_EXTERNAL_MODULE_rxjs__;\n\n//# sourceURL=webpack://redogs/external_%7B%22root%22:%5B%22rxjs%22%5D,%22commonjs%22:%22rxjs%22,%22commonjs2%22:%22rxjs%22,%22amd%22:%22rxjs%22%7D?");

/***/ }),

/***/ "rxjs/operators":
/*!******************************************************************************************************************************!*\
  !*** external {"root":["rxjs","operators"],"commonjs":"rxjs/operators","commonjs2":"rxjs/operators","amd":"rxjs/operators"} ***!
  \******************************************************************************************************************************/
/*! no static exports found */
/***/ (function(module, exports) {

eval("module.exports = __WEBPACK_EXTERNAL_MODULE_rxjs_operators__;\n\n//# sourceURL=webpack://redogs/external_%7B%22root%22:%5B%22rxjs%22,%22operators%22%5D,%22commonjs%22:%22rxjs/operators%22,%22commonjs2%22:%22rxjs/operators%22,%22amd%22:%22rxjs/operators%22%7D?");

/***/ }),

/***/ "tslib":
/*!************************!*\
  !*** external "tslib" ***!
  \************************/
/*! no static exports found */
/***/ (function(module, exports) {

eval("module.exports = __WEBPACK_EXTERNAL_MODULE_tslib__;\n\n//# sourceURL=webpack://redogs/external_%22tslib%22?");

/***/ })

/******/ });
});